/*
 * Copyright (c) 2003 Rozhuk Ivan <rozhuk.im@gmail.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */



#if !defined(AFX_REPORTERROR__H__INCLUDED_)
#define AFX_REPORTERROR__H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef MB_SERVICE_NOTIFICATION
	#define MB_SERVICE_NOTIFICATION 0
#endif

#include <RasError.h>


__inline void ReportError(DWORD dwErrorCode)
{
	HWND hWnd=GetActiveWindow();
	TCHAR szErrText[1048],szErrDescription[1024],szAppPath[MAX_PATH];


	szErrDescription[0]=0;
	GetModuleFileName(NULL,szAppPath,MAX_PATH);

#ifdef RasGetErrorString
	if (dwErrorCode>RASBASE && dwErrorCode<RASBASEEND)
	{
		RasGetErrorString(dwErrorCode,szErrDescription,1000);
	}else{
#else
	{
#endif
		szErrDescription[FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,NULL,dwErrorCode,0,szErrDescription,1000,NULL)]=0;
	}
	wsprintf(szErrText,TEXT("ERROR %lu: %s"),dwErrorCode,szErrDescription);

	MessageBox(hWnd,szErrText,szAppPath,(MB_OK | ((hWnd==NULL) ? MB_SERVICE_NOTIFICATION:0)));
}



#endif // !defined(AFX_REPORTERROR__H__INCLUDED_)


